<template>
    <div
            class="page-table scrollable only-y"
            id="affix-container"
    >
        <div class>
            <h1>Roles</h1>
            <!--<h4>for a better experience on Mac OS during horizontal scroll is prefered disable the "Swipe between pages" option </h4>-->

            <el-breadcrumb separator="/">
                <el-breadcrumb-item :to="{ path: '/' }">
                    <i class="mdi mdi-home-outline"></i>
                </el-breadcrumb-item>
                <el-breadcrumb-item :to="{ path: '/roles' }">Roles</el-breadcrumb-item>
                <el-breadcrumb-item> {{pathName.length  < 50 ? pathName : pathName.substring(0,45)+'...'}}</el-breadcrumb-item>

            </el-breadcrumb>
        </div>
        <br/>
        <el-card v-show="isContentFound" style="text-align: left; margin: 20px 0"  v-loading="loading">
            <not-found></not-found>
        </el-card>
        <div v-show="!isContentFound">
            <el-card
                    class="box-card"
                    style="text-align: left; margin: 20px 0"
                    v-loading="loading"
            >
                <div
                        class="form-box"
                >
                    <el-form
                            :rules="rules"
                            ref="detail"
                            :model="detail"
                    >
                        <el-row :gutter="30">
                            <el-col
                                    :span="24"
                                    :md="24"
                                    :sm="24"
                                    :xs="24"
                                    class="col-p"
                            >
                                <el-form-item
                                        label=" Name"
                                        prop="name"
                                >
                                    <el-input v-model="detail.name" @keyup.enter.native="save"/>
                                </el-form-item>
                            </el-col>
                        </el-row>
                        <el-row :gutter="30">
                            <el-col
                                    :span="24"
                                    :md="24"
                                    :sm="24"
                                    :xs="24"
                                    class="col-p"
                            >
                            </el-col>
                        </el-row>
                        <el-row :gutter="30">
                        <el-col
                                :span="24"
                                :md="24"
                                :sm="24"
                                :xs="24"
                                class="col-p"
                        >
                            <el-form-item
                                    label="Description"
                                    prop="description"
                            >
                                <el-input
                                        type="text"
                                        v-model="detail.description"
                                        @keyup.enter.native="save"
                                ></el-input>
                            </el-form-item>
                        </el-col>
                    </el-row>
                    <el-row :gutter="30">
                        <el-col
                                :span="24"
                                :md="24"
                                :sm="24"
                                :xs="24"
                                class="col-p"
                        >
                            <el-form-item
                                    label="Permissions"
                            ><br/>
                                <el-tag
                                        v-for="item in detail.permissions"
                                        class="mr-5 vertical-top"
                                        :key="item.id"
                                >
                                    {{item.display_name}}
                                </el-tag>
                                <el-button class="vertical-top" type="primary" size="small" icon="el-icon-plus" @click="onShowAddPermission"></el-button>

                            </el-form-item>
                        </el-col>
                    </el-row>
                        <!--<el-checkbox v-for="item in permissions"-->
                        <!--v-model='item.checked'-->
                        <!--:label="item.display_name">-->
                        <!--</el-checkbox>-->
                    </el-form>
                    <div>
                        <div style="display: inline;">
                            <div class="btn-right ">
                                <el-button
                                        icon="mdi mdi-content-save-outline "
                                        type="primary"
                                        @click="save"
                                        @keyup.enter="save"
                                > Save changes
                                </el-button>
                            </div>
                        </div>

                        <div>
                            <div class="btn-left ">
                                <el-button
                                        class="text-red"
                                        type="text"
                                        @click="onRemove(detail.id, $event)"
                                >Delete
                                </el-button>
                            </div>
                        </div>
                    </div>
                </div>
            </el-card>
            <role-has-permission
                    v-if="roles.length > 0 && detail.id"
                    :dialogvisible.sync="dialogvisible"
                    :detail="detail"
                    :permissions="permissions"
                    :roles="roles"
                    :selectedPermissions="detail.permissions"
                    rerefreshList
            ></role-has-permission>
        </div>

    </div>
</template>

<script>
    import RoleHasPermission from "~/components/dialogs/RoleHasPermission";
    import {permission as permissionAPI, role as roleAPI} from '~/services/apis/index'
    import NotFound from '../ContentNotFound'

    export default {
        name: 'AddRole',
        components: {
            NotFound,
            RoleHasPermission
        },
        data() {

            return {
                detail: {
                    id: '',
                    name: '',
                    display_name: '',
                    description: '',
                    created_at: "",
                    updated_at: "",
                    permissions_id: [],
                    permissions: []
                },
                pathName: '',
                isIndeterminate: true,
                loading: true,
                permissions: [],
                roles: [],
                dialogvisible: false,
                isContentFound: false,
                isDisabledVerify: false,
                isDisabledSave: false,
                rules: {
                    name: [
                        {required: true, message: 'Please input name', trigger: 'blur'},
                        {max: 255, message: 'Length must be less than 256', trigger: 'blur'}
                    ],
                    display_name: [
                        {required: true, message: 'Please input display name', trigger: 'blur'},
                        {max: 255, message: 'Length must be less than 256', trigger: 'blur'}
                    ],
                    description: [
                        {max: 255, message: 'Length must be less than 256', trigger: 'blur'}
                    ],
                },
            }
        },
        methods: {

            getRoles() {
                roleAPI.getRoles().then(res => {
                    this.roles = res.data.data;
                })
                    .catch(err => {

                    });
            },
            getRole() {
                roleAPI.getRole(this.$route.params.id)
                    .then(res => {
                        this.detail = res.data.data;
                        let { name } = res.data.data;
                        this.pathName =name;
                        this.isContentFound = false;
                        this.loading = false;

                    })
                    .catch(err => {
                        this.isContentFound = true;
                        this.loading = false;
                    });
            },

            getPermissions() {
                permissionAPI.getPermissions()
                    .then((res) => {
                        /* eslint-disable no-console */
                        // this.initPermissions(res.data.data);
                        this.permissions = res.data.data;
                        this.loading = false;
                    })
                    .catch((err) => {
                        this.$notify({
                            type: 'error',
                            title: 'Error',
                            message: err
                        })
                        this.loading = false;
                    })
            },

            // initPermissions(data) {
            //     if (!data) return;
            //     this.permissions = data;
            // },

            save() {
                this.loading = true;
                this.$refs['detail'].validate((valid) => {
                    if (valid) {
                        this.submit();
                    } else {
                        this.loading = false;
                        return false;
                    }
                });

            },
            submit() {
                let checkedId = [];
                this.permissions.map(item => {
                    if (item.checked) {
                        checkedId.push(item.id);
                    }
                });
                let data = {
                    name: this.detail.name,
                    display_name: this.detail.display_name,
                    description: this.detail.description
                };
                roleAPI.updateRole(this.$route.params.id, data)
                    .then((res) => {
                        /*eslint-disable*/
                        this.$notify({
                            title: "Success",
                            message: "Edit role successfully!",
                            type: "success"
                        });
                        this.loading = false;
                        this.$router.push({name: 'role'});
                    })
                    .catch((err) => {
                        this.$notify({
                            title: "Error",
                            message: "Edit role failed!",
                            type: "error"
                        });
                        this.loading = false;
                    })
            },
            onRemove(id, event) {
                // this.loading = true;
                if (event) {
                    event.preventDefault();
                    event.stopPropagation();
                }

                this.$confirm('Are you sure you want to delete this role?', 'Warning', {
                    confirmButtonText: 'Yes',
                    cancelButtonText: 'Cancel',
                    type: 'warning',
                    center: true
                }).then(() => {
                    roleAPI.removeRole(id)
                        .then((res) => {
                            if (res.status === 204) {
                                this.$notify({
                                    title: 'Success',
                                    message: 'Delete role successfully!',
                                    type: 'success'
                                });

                                this.loading = false;
                                this.$router.push({name: 'role'});
                                // this.getListData();
                            }
                        })
                        .catch(() => {
                            this.$notify.error({
                                title: 'Error',
                                message: 'Cannot delete role'
                            });
                            this.loading = false;
                        })
                }).catch((err) => {
                    this.loading = false;
                });
            },
            onShowAddPermission(){
                this.dialogvisible = true;
            }

        },

        mounted() {
            this.getRole();
            this.getRoles();
            this.getPermissions();
        }
    }
</script>

<style lang="scss">

    .vertical-top{
        vertical-align: top;
    }
</style>
